package com.example.wendelyn.test2;

import android.content.ContentResolver;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.ListView;
import android.widget.Toast;

import java.util.ArrayList;

/**
 * Created by Wendelyn on 12/14/2015.
 */
public class AlertsActivity extends AppCompatActivity implements AdapterView.OnItemClickListener {
    private static final String USERNAME = "username_WW";
    private static final String WATCHID= "watch_number_WW";

    private static AlertsActivity inst;
    ArrayList<String> smsMessagesList = new ArrayList<String>();
    ListView smsListView;
    ArrayAdapter arrayAdapter;

    public static AlertsActivity instance() {
        return inst;
    }

    @Override
    public void onStart() {
        super.onStart();
        inst = this;
    }

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.alerts_page);

        final SharedPreferences prefs = getSharedPreferences("com.example.wendelyn.test2", Context.MODE_PRIVATE);
        if (prefs.getString(USERNAME,"").equals("")) {
            finish();
            Intent myIntent = new Intent(AlertsActivity.this, LoginActivity.class);
            AlertsActivity.this.startActivity(myIntent);
        }

        View.OnClickListener goBack = new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
                Intent myIntent = new Intent(AlertsActivity.this, MainActivity.class);
                AlertsActivity.this.startActivity(myIntent);
            }
        };
        Button goBtn = (Button) findViewById(R.id.goButton);
        goBtn.setOnClickListener(goBack);

        smsListView = (ListView) findViewById(R.id.messageList);
        arrayAdapter = new ArrayAdapter<String>(this, android.R.layout.simple_list_item_1, smsMessagesList);
        smsListView.setAdapter(arrayAdapter);
        smsListView.setOnItemClickListener(this);

        refreshSmsInbox();
    }

    public void refreshSmsInbox() {
        ContentResolver contentResolver = getContentResolver();
        Cursor smsInboxCursor = contentResolver.query(Uri.parse("content://sms/inbox"), null, null, null, null);
        int indexBody = smsInboxCursor.getColumnIndex("body");
        int indexAddress = smsInboxCursor.getColumnIndex("address");
        if (indexBody < 0 || !smsInboxCursor.moveToFirst()) return;
        arrayAdapter.clear();

        final SharedPreferences prefs = getSharedPreferences("com.example.wendelyn.test2", Context.MODE_PRIVATE);
        String watchNumber;
        if (prefs.getString(WATCHID,"").equals("")){
            watchNumber = "256447";
        } else {
            watchNumber = "+1" + prefs.getString(WATCHID,""); // +1 must be added to phone numbers to show the right ones.
        }

        String str;
        do {
            //Check the address against that of the Watch
            if ((smsInboxCursor.getString(indexAddress)).equals(watchNumber)) {
                str = "SMS From: " + smsInboxCursor.getString(indexAddress) +
                        "\n" + smsInboxCursor.getString(indexBody) + "\n";
                arrayAdapter.add(str);
            }
        } while (smsInboxCursor.moveToNext());

        if(arrayAdapter.isEmpty()){
            str = "No Messages Available";
            arrayAdapter.add(str);
        }
    }

    public void updateList(final String smsMessage) {
        arrayAdapter.insert(smsMessage, 0);
        arrayAdapter.notifyDataSetChanged();
    }

    public void onItemClick(AdapterView<?> parent, View view, int pos, long id) {
        try {
            String[] smsMessages = smsMessagesList.get(pos).split("\n");
            String address = smsMessages[0];
            String smsMessage = "";
            for (int i = 1; i < smsMessages.length; ++i) {
                smsMessage += smsMessages[i];
            }

            String smsMessageStr = address + "\n";
            smsMessageStr += smsMessage;
            Toast.makeText(this, smsMessageStr, Toast.LENGTH_SHORT).show();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
