package com.example.wendelyn.test2;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

/**
 * Created by Wendelyn on 12/14/2015.
 */
public class MainActivity extends AppCompatActivity {
    private static final String USERNAME = "username_WW";
    private String username;

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.main_page);

        final SharedPreferences prefs = getSharedPreferences("com.example.wendelyn.test2", Context.MODE_PRIVATE);
        if (prefs.getString(USERNAME,"").equals("")){
            //Go back to the login screen, because there is no user data.
            finish();
            Intent myIntent = new Intent(MainActivity.this, LoginActivity.class);
            MainActivity.this.startActivity(myIntent);
        }
        else{
            username = prefs.getString(USERNAME,"");
        }

        TextView greetText = (TextView) findViewById(R.id.greeting);
        greetText.setText("Welcome, " + username + ".");

        //Map Button
        OnClickListener mapListen = new OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
                Intent myIntent = new Intent(MainActivity.this, MapActivity.class);
                MainActivity.this.startActivity(myIntent);
            }
        };
        Button mapBtn = (Button) findViewById(R.id.MapButton);
        mapBtn.setOnClickListener(mapListen);

        //Alert Button
        OnClickListener alertsListen = new OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
                Intent myIntent = new Intent(MainActivity.this, AlertsActivity.class);
                MainActivity.this.startActivity(myIntent);
            }
        };
        Button alertsBtn = (Button) findViewById(R.id.AlertButton);
        alertsBtn.setOnClickListener(alertsListen);

        //Settings Button
        OnClickListener settingsListen = new OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
                Intent myIntent = new Intent(MainActivity.this, SettingsActivity.class);
                MainActivity.this.startActivity(myIntent);
            }
        };
        Button settingsBtn = (Button) findViewById(R.id.SettingsButton);
        settingsBtn.setOnClickListener(settingsListen);

        //Log out
        OnClickListener logListen = new OnClickListener() {
            @Override
            public void onClick(View v) {
                finish();
                Intent myIntent = new Intent(MainActivity.this, LoginActivity.class);
                MainActivity.this.startActivity(myIntent);
            }
        };
        Button logBtn = (Button) findViewById(R.id.LogOut);
        logBtn.setOnClickListener(logListen);
    }
}
