package com.example.wendelyn.test2;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.AutoCompleteTextView;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

/**
 * Created by Wendelyn on 12/15/2015.
 */
public class RegisterActivity extends AppCompatActivity {
    private AutoCompleteTextView mNameView;
    private AutoCompleteTextView mEmailView;
    private EditText mPasswordView;

    private static final String USERNAME = "username_WW";
    private static final String EMAIL = "email_WW";
    private static final String PASSWORD = "password_WW";

    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.register_page);

        mNameView = (AutoCompleteTextView) findViewById(R.id.nameField);
        mEmailView = (AutoCompleteTextView) findViewById(R.id.emailField);
        mPasswordView = (EditText) findViewById(R.id.passwordField);


        OnClickListener registerLtn = new OnClickListener() {
            @Override
            public void onClick(View v) {
                attemptRegister();
            }
        };
        Button registerAccount = (Button) findViewById(R.id.registerButton);
        registerAccount.setOnClickListener(registerLtn);

        OnClickListener cancelLtn = new OnClickListener() {
            @Override
            public void onClick(View v) {
                //Clear preferences just in case when canceling.
                SharedPreferences.Editor deletePrefs = getSharedPreferences("com.example.wendelyn.test2", Context.MODE_PRIVATE).edit();
                deletePrefs.clear().commit();

                Intent myIntent = new Intent(RegisterActivity.this, LoginActivity.class);
                RegisterActivity.this.startActivity(myIntent);
            }
        };
        Button cancelAction = (Button) findViewById(R.id.cancelButton);
        cancelAction.setOnClickListener(cancelLtn);
    }

    private void attemptRegister() {
        mNameView.setError(null);
        mEmailView.setError(null);
        mPasswordView.setError(null);

        String nameW = mNameView.getText().toString();
        String emailW = mEmailView.getText().toString();
        String passwordW = mPasswordView.getText().toString();

        boolean cancel = false;
        View focusView = null;

        if (nameW.equals("")){
            mNameView.setError(getString(R.string.error_invalid_name));
            focusView = mNameView;
            cancel = true;
        }

        if (!emailW.contains("@")){
            mEmailView.setError(getString(R.string.error_invalid_email));
            focusView = mEmailView;
            cancel = true;
        }

        if (passwordW.length() < 3){
            mPasswordView.setError((getString(R.string.error_invalid_password)));
            focusView = mPasswordView;
            cancel = true;
        }

        if (nameW.contains(" ") || emailW.contains(" ") || passwordW.contains(" ")){
            mNameView.setError((getString(R.string.error_spaces)));
            focusView = mNameView;
            cancel = true;
        }

        if (cancel) {
            // There was an error; don't attempt register and focus the first
            // form field with an error.
            focusView.requestFocus();
        }
        else {
            SharedPreferences.Editor editor = getSharedPreferences("com.example.wendelyn.test2", Context.MODE_PRIVATE).edit();
            editor.putString(USERNAME, nameW);
            editor.putString(EMAIL, emailW);
            editor.putString(PASSWORD, passwordW);
            editor.apply();

            Toast.makeText(RegisterActivity.this, R.string.action_success_register, Toast.LENGTH_SHORT).show();
            finish();
            Intent myIntent = new Intent(RegisterActivity.this, WatchActivity.class);
            RegisterActivity.this.startActivity(myIntent);
            //Later on, move to a new page to get the watchData (phone #, and geofence data (longitude, latitude, and radius), to save in the same file.
        }
    }
}