package com.example.wendelyn.test2;

import android.content.BroadcastReceiver;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.telephony.SmsMessage;
import android.util.Log;

/**
 * Created by Wendelyn on 12/16/2015.
 */
public class SmsBroadcastReceiver extends BroadcastReceiver {
    public static final String SMS_BUNDLE = "pdus";

    public void onReceive(Context context, Intent intent) {
        Bundle intentExtras = intent.getExtras();

        try {
            if (intentExtras != null) {
                Object[] sms = (Object[]) intentExtras.get(SMS_BUNDLE);
                String smsMessageStr = "";

                assert sms != null;
                for (int i = 0; i < sms.length; ++i) {
                    //NOTE createFromPdu uses minSdkVersion 23, see build.gradle file
                    //Also, "3gpp" is used to indicate the format of the messages.
                    SmsMessage smsMessage = SmsMessage.createFromPdu((byte[]) sms[i]);

                    String smsBody = smsMessage.getMessageBody();
                    String address = smsMessage.getOriginatingAddress();
                }

                //this will update the UI with message
                AlertsActivity inst = AlertsActivity.instance();
                inst.updateList(smsMessageStr);
            }
        } catch (Exception e){
            Log.e("SMSReceiver", "Exception smsReceiver" +e);
        }
    }
}
