package com.example.wendelyn.test2;

import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;
import android.util.Log;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;
import android.telephony.SmsManager;

/**
 * Created by Wendelyn on 3/2/2016.
 */
public class WatchActivity extends AppCompatActivity{
    private final static int REQUEST_ENABLE_BT = 1;

    private static final String WATCHID= "watch_number_WW";
    private EditText mWatchID;
    private EditText mPhone;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.watch_page);

        mWatchID = (EditText) findViewById(R.id.watchIDfield);
        mPhone = (EditText) findViewById(R.id.phoneField);

        View.OnClickListener okListen = new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                attemptSaveWatch();
            }
        };
        Button okBtn = (Button) findViewById(R.id.okButton);
        okBtn.setOnClickListener(okListen);

        View.OnClickListener cancelLtn = new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                //Clear preferences just in case when canceling.
                SharedPreferences.Editor deletePrefs = getSharedPreferences("com.example.wendelyn.test2", Context.MODE_PRIVATE).edit();
                deletePrefs.clear().commit();

                Intent myIntent = new Intent(WatchActivity.this, LoginActivity.class);
                WatchActivity.this.startActivity(myIntent);
            }
        };
        Button cancelAction = (Button) findViewById(R.id.cancelButton);
        cancelAction.setOnClickListener(cancelLtn);
    }

    private void attemptSaveWatch(){
        mWatchID.setError(null);
        String watchNumber = mWatchID.getText().toString();

        mPhone.setError(null);
        String phoneNumber = mPhone.getText().toString();

        boolean cancel = false;
        View focusView = null;

        if(watchNumber.equals("")){
            mWatchID.setError(getString(R.string.error_field_required));
            focusView = mWatchID;
            cancel = true;
        }
        if(watchNumber.length() < 10){
            mWatchID.setError(getString(R.string.error_number_short));
            focusView = mWatchID;
            cancel = true;
        }
        if(watchNumber.contains(" ") || watchNumber.contains("-")){
            mWatchID.setError(getString(R.string.error_number_character));
            focusView = mWatchID;
            cancel = true;
        }

        if(phoneNumber.equals("")){
            mPhone.setError(getString(R.string.error_field_required));
            focusView = mPhone;
            cancel = true;
        }
        if(phoneNumber.length() < 10){
            mPhone.setError(getString(R.string.error_number_short));
            focusView = mPhone;
            cancel = true;
        }
        if(phoneNumber.contains(" ") || phoneNumber.contains("-")){
            mPhone.setError(getString(R.string.error_number_character));
            focusView = mPhone;
            cancel = true;
        }

        if (cancel) {
            // There was an error; don't attempt register and focus the first
            // form field with an error.
            focusView.requestFocus();
        }
        else{
            SharedPreferences.Editor editor = getSharedPreferences("com.example.wendelyn.test2", Context.MODE_PRIVATE).edit();
            editor.putString(WATCHID, watchNumber);
            editor.apply();

            //Send the initialization text message here
            sendSMSMessage(phoneNumber);

            finish();
            Intent myIntent = new Intent(WatchActivity.this, GeofenceActivity.class);
            WatchActivity.this.startActivity(myIntent);
        }
    }

    protected void sendSMSMessage(String phoneMessage) {
        final SharedPreferences prefs = getSharedPreferences("com.example.wendelyn.test2", Context.MODE_PRIVATE);
        Log.i("Send SMS", "");
        String phoneNo = "+1" + prefs.getString(WATCHID,"");

        try {
            SmsManager smsManager = SmsManager.getDefault();
            smsManager.sendTextMessage(phoneNo, null, phoneMessage, null, null);
            Toast.makeText(getApplicationContext(), "SMS sent.", Toast.LENGTH_LONG).show();
        }
        catch (Exception e) {
            Toast.makeText(getApplicationContext(), "SMS failed, please try again.", Toast.LENGTH_LONG).show();
            e.printStackTrace();
        }
    }
}
